Option Explicit On
Option Strict Off

Imports System.Runtime.InteropServices

Module PVG16B

    '
    ' Return Value
    '
    Public Const PVG16B_OK As Integer = 0
    Public Const PVG16B_INVALID_ID As Integer = 1
    Public Const PVG16B_DEVICE_NOT_FOUND As Integer = 2
    Public Const PVG16B_DEVICE_NOT_OPENED As Integer = 3
    Public Const PVG16B_OTHER_ERROR As Integer = 4
    Public Const PVG16B_COMMUNICATION_ERROR As Integer = 5
    Public Const PVG16B_INVALID_PARAMETER As Integer = 6
    Public Const PVG16B_EXECUTION_ERROR As Integer = 7
    Public Const PVG16B_MEMORY_ERROR As Integer = 8

    '
    ' Constants
    '

    ' Output mode
    Public Const PVG16B_OUTPUT_MODE_DIRECT As Byte = 0					' Direct mode (direct output)
    Public Const PVG16B_OUTPUT_MODE_PC_START As Byte = 1				' Program mode (use step memory)
    Public Const PVG16B_OUTPUT_MODE_TRIGGER_START_RISING As Byte = 2	' Program mode (use step memory)
    Public Const PVG16B_OUTPUT_MODE_TRIGGER_START_FALLING As Byte = 3	' Program mode (use step memory)
    Public Const PVG16B_OUTPUT_MODE_STEP_TRIGGER_RISING As Byte = 4		' Program mode (use step memory)
    Public Const PVG16B_OUTPUT_MODE_STEP_TRIGGER_FALLING As Byte = 5	' Program mode (use step memory)

    ' Status (for Program mode)
    Public Const PVG16B_STATUS_NODATA As Byte = 0
    Public Const PVG16B_STATUS_READY As Byte = 1
    Public Const PVG16B_STATUS_WAITING As Byte = 2
    Public Const PVG16B_STATUS_RUNNING As Byte = 3

    '
    ' Device Functions
    '
    Public Declare Function PVG16B_GetNumberOfDevices Lib "PVG16B.dll" (ByRef Number As Integer) As Integer
    Public Declare Function PVG16B_GetSerialNumber Lib "PVG16B.dll" (ByVal Index As Integer, ByRef SerialNumber As Integer) As Integer
    Public Declare Function PVG16B_Open Lib "PVG16B.dll" (ByRef ID As Byte) As Integer
    Public Declare Function PVG16B_OpenBySerialNumber Lib "PVG16B.dll" (ByVal SerialNumber As Integer, ByRef ID As Byte) As Integer
    Public Declare Function PVG16B_Close Lib "PVG16B.dll" (ByVal ID As Byte) As Integer

    '
    ' D/A Control Functions
    '
    Public Declare Function PVG16B_GetStatus Lib "PVG16B.dll" (ByVal ID As Byte, ByRef Status As Byte, ByRef ExtState As Byte) As Integer
    Public Declare Function PVG16B_GetOutputMode Lib "PVG16B.dll" (ByVal ID As Byte, ByRef Mode As Byte) As Integer
    Public Declare Function PVG16B_SetOutputMode Lib "PVG16B.dll" (ByVal ID As Byte, ByVal Mode As Byte) As Integer
    Public Declare Function PVG16B_DirectOutput Lib "PVG16B.dll" (ByVal ID As Byte, ByVal Voltage As Double) As Integer
    Public Declare Function PVG16B_GetStepTime Lib "PVG16B.dll" (ByVal ID As Byte, ByRef Time As Integer) As Integer
    Public Declare Function PVG16B_SetStepTime Lib "PVG16B.dll" (ByVal ID As Byte, ByVal Time As Integer) As Integer
    Public Declare Function PVG16B_GetStepCount Lib "PVG16B.dll" (ByVal ID As Byte, ByRef Count As Integer) As Integer
    Public Declare Function PVG16B_WriteStepMemory Lib "PVG16B.dll" (ByVal ID As Byte, <MarshalAs(UnmanagedType.AsAny), InAttribute(), OutAttribute()> ByVal Data As Object, ByVal Count As Integer) As Integer
    Public Declare Function PVG16B_ReadStepCounter Lib "PVG16B.dll" (ByVal ID As Byte, ByRef Counter As Integer) As Integer
	Public Declare Function PVG16B_Start Lib "PVG16B.dll" (ByVal ID As Byte) As Integer
    Public Declare Function PVG16B_Cancel Lib "PVG16B.dll" (ByVal ID As Byte) As Integer

End Module
