Attribute VB_Name = "PVG16B"
Option Explicit

'
' Return Value
'
Public Const PVG16B_OK As Long = 0
Public Const PVG16B_INVALID_ID As Long = 1
Public Const PVG16B_DEVICE_NOT_FOUND As Long = 2
Public Const PVG16B_DEVICE_NOT_OPENED As Long = 3
Public Const PVG16B_OTHER_ERROR As Long = 4
Public Const PVG16B_COMMUNICATION_ERROR As Long = 5
Public Const PVG16B_INVALID_PARAMETER As Long = 6
Public Const PVG16B_EXECUTION_ERROR As Long = 7
Public Const PVG16B_MEMORY_ERROR As Long = 8

'
' Constants
'

' Output mode
Public Const PVG16B_OUTPUT_MODE_DIRECT As Byte = 0					' Direct mode (direct output)
Public Const PVG16B_OUTPUT_MODE_PC_START As Byte = 1				' Program mode (use step memory)
Public Const PVG16B_OUTPUT_MODE_TRIGGER_START_RISING As Byte = 2	' Program mode (use step memory)
Public Const PVG16B_OUTPUT_MODE_TRIGGER_START_FALLING As Byte = 3	' Program mode (use step memory)
Public Const PVG16B_OUTPUT_MODE_STEP_TRIGGER_RISING As Byte = 4		' Program mode (use step memory)
Public Const PVG16B_OUTPUT_MODE_STEP_TRIGGER_FALLING As Byte = 5	' Program mode (use step memory)

' Status (for Program mode)
Public Const PVG16B_STATUS_NODATA As Byte = 0
Public Const PVG16B_STATUS_READY As Byte = 1
Public Const PVG16B_STATUS_WAITING As Byte = 2
Public Const PVG16B_STATUS_RUNNING As Byte = 3

'
' Device Functions
'
Public Declare Function PVG16B_GetNumberOfDevices Lib "PVG16B.dll" (ByRef Number As Long) As Long
Public Declare Function PVG16B_GetSerialNumber Lib "PVG16B.dll" (ByVal Index As Long, ByRef SerialNumber As Long) As Long
Public Declare Function PVG16B_Open Lib "PVG16B.dll" (ByRef ID As Byte) As Long
Public Declare Function PVG16B_OpenBySerialNumber Lib "PVG16B.dll" (ByVal SerialNumber As Long, ByRef ID As Byte) As Long
Public Declare Function PVG16B_Close Lib "PVG16B.dll" (ByVal ID As Byte) As Long

'
' D/A Control Functions
'
Public Declare Function PVG16B_GetStatus Lib "PVG16B.dll" (ByVal ID As Byte, ByRef Status As Byte, ByRef ExtState As Byte) As Long
Public Declare Function PVG16B_GetOutputMode Lib "PVG16B.dll" (ByVal ID As Byte, ByRef Mode As Byte) As Long
Public Declare Function PVG16B_SetOutputMode Lib "PVG16B.dll" (ByVal ID As Byte, ByVal Mode As Byte) As Long
Public Declare Function PVG16B_DirectOutput Lib "PVG16B.dll" (ByVal ID As Byte, ByVal Voltage As Double) As Long
Public Declare Function PVG16B_GetStepTime Lib "PVG16B.dll" (ByVal ID As Byte, ByRef Time As Long) As Long
Public Declare Function PVG16B_SetStepTime Lib "PVG16B.dll" (ByVal ID As Byte, ByVal Time As Long) As Long
Public Declare Function PVG16B_GetStepCount Lib "PVG16B.dll" (ByVal ID As Byte, ByRef Count As Long) As Long
Public Declare Function PVG16B_WriteStepMemory Lib "PVG16B.dll" (ByVal ID As Byte, ByRef Data As Double, ByVal Count As Long) As Long
Public Declare Function PVG16B_ReadStepCounter Lib "PVG16B.dll" (ByVal ID As Byte, ByRef Counter As Long) As Long
Public Declare Function PVG16B_Start Lib "PVG16B.dll" (ByVal ID As Byte) As Long
Public Declare Function PVG16B_Cancel Lib "PVG16B.dll" (ByVal ID As Byte) As Long
